$(function () {
    $("#jqGrid").jqGrid({
        url: '../mkstorepromtype/list',
        datatype: "json",
        colModel: [
			{label: 'promTypeId', name: 'promTypeId', index: 'prom_type_id', key: true, hidden: true},
			{label: '活动类别主题', name: 'title', index: 'title', width: 80},
			{label: '活动类别名称', name: 'promTypeName', index: 'prom_type_name', width: 80},
			{label: '活动类别图片链接', name: 'picUrl', index: 'pic_url', width: 80},
			{label: '是否有效,0:有效，1:无效', name: 'isValid', index: 'is_valid', width: 80},
			{label: '备注', name: 'note', index: 'note', width: 80},
			{label: '创建人编号', name: 'createrSn', index: 'creater_sn', width: 80},
			{label: '创建时间', name: 'createTime', index: 'create_time', width: 80},
			{label: '修改人编号', name: 'moderSn', index: 'moder_sn', width: 80},
			{label: '修改时间', name: 'modTime', index: 'mod_time', width: 80},
			{label: '时间戳', name: 'tstm', index: 'tstm', width: 80}],
		viewrecords: true,
        height: 550,
        rowNum: 10,
        rowList: [10, 30, 50],
        rownumbers: true,
        rownumWidth: 25,
        autowidth: true,
        multiselect: true,
        pager: "#jqGridPager",
        jsonReader: {
            root: "page.list",
            page: "page.currPage",
            total: "page.totalPage",
            records: "page.totalCount"
        },
        prmNames: {
            page: "page",
            rows: "limit",
            order: "order"
        },
        gridComplete: function () {
            $("#jqGrid").closest(".ui-jqgrid-bdiv").css({"overflow-x": "hidden"});
        }
    });
});

let vm = new Vue({
	el: '#rrapp',
	data: {
        showList: true,
        title: null,
		mkStorePromType: {},
		ruleValidate: {
			name: [
				{required: true, message: '名称不能为空', trigger: 'blur'}
			]
		},
		q: {
		    name: ''
		}
	},
	methods: {
		query: function () {
			vm.reload();
		},
		add: function () {
			vm.showList = false;
			vm.title = "新增";
			vm.mkStorePromType = {};
		},
		update: function (event) {
            let promTypeId = getSelectedRow();
			if (promTypeId == null) {
				return;
			}
			vm.showList = false;
            vm.title = "修改";

            vm.getInfo(promTypeId)
		},
		saveOrUpdate: function (event) {
            let url = vm.mkStorePromType.promTypeId == null ? "../mkstorepromtype/save" : "../mkstorepromtype/update";
			$.ajax({
				type: "POST",
			    url: url,
			    contentType: "application/json",
			    data: JSON.stringify(vm.mkStorePromType),
                success: function (r) {
                    if (r.code === 0) {
                        alert('操作成功', function (index) {
                            vm.reload();
                        });
                    } else {
                        alert(r.msg);
                    }
                }
			});
		},
		del: function (event) {
            let promTypeIds = getSelectedRows();
			if (promTypeIds == null){
				return;
			}

			confirm('确定要删除选中的记录？', function () {
				$.ajax({
					type: "POST",
				    url: "../mkstorepromtype/delete",
				    contentType: "application/json",
				    data: JSON.stringify(promTypeIds),
				    success: function (r) {
						if (r.code == 0) {
							alert('操作成功', function (index) {
								$("#jqGrid").trigger("reloadGrid");
							});
						} else {
							alert(r.msg);
						}
					}
				});
			});
		},
		getInfo: function(promTypeId){
			$.get("../mkstorepromtype/info/"+promTypeId, function (r) {
                vm.mkStorePromType = r.mkStorePromType;
            });
		},
        reloadSearch: function() {
            vm.q = {
                name: ''
            }
            vm.reload();
		},
		reload: function (event) {
			vm.showList = true;
            let page = $("#jqGrid").jqGrid('getGridParam', 'page');
			$("#jqGrid").jqGrid('setGridParam', {
                postData: {'name': vm.q.name},
                page: page
            }).trigger("reloadGrid");
            vm.handleReset('formValidate');
		},
        handleSubmit: function (name) {
            handleSubmitValidate(this, name, function () {
                vm.saveOrUpdate()
            });
        },
        handleReset: function (name) {
            handleResetForm(this, name);
        }
	}
});